/*
 * HI-TECHİȨ
 * 18Fxxx BOOT LOADER,  2002 HI-TECH ˾Ȩ
 * ɷʹ
 * еκΣԼеʹ÷
 * 
 */

/////////////////////////////////////
//PIC18 BootLoader             //
//޸HTSoftBootLoader     //
//ʹ򣬵Ǳ //
//ЩԳ //
//޸ģҲҪҷһݡ       //
//                                 //
//޸ģ                     //
//      20051                  //
//  __      __                     //
// (  / _   _/ '(__/_   _          //
//__)/)(/()/__/  / (//)(/ @126.com //
//                    _/           //
////////////////////////////////////\

#pragma psect text=bootldr
#pragma psect const=code
#include <pic18.h>
#include "bootldr.h"

/*
#if defined(MPLAB_ICD)
__CONFIG(4,DEBUGEN);
#endif
#ifdef __PIC18FX520
__CONFIG(5,UNPROTECT);
#else
__CONFIG(5,CPB & UNPROTECT);
#endif
*/

#if defined(ERRATA_FXX2_B3) || defined(ERRATA_FXX8_B4)
#error Command line option -NOERRATA must be specified when compiling this code for this device.
#endif

/* ܺ */
void checksum(void);
void putch(unsigned char);
void puts(const char *s);
unsigned char gx(void);
unsigned char g2x(void);
void zap(void);
void table_write(void);
void flash8(void);
void clear_buffer(void);

persistent near unsigned char buff[8];  /* 8 ֽڱ̻ */
persistent near unsigned char DO_NOT_INCREMENT;
persistent near unsigned char cksum,rectype,bcount;
persistent near unsigned char delay_time;
persistent near unsigned char index;
persistent near unsigned short erase;
persistent near unsigned char SerialNo;

#asm

psect intcode    // ضȼж
  goto  PROG_START+8

psect intcodelo  // ضȼж
  goto  PROG_START+0x18

#endasm

#asm
global _checksum
_checksum:
  call  _g2x        // ȡУֽ
  movf  _cksum,w,c
  btfss status,2,c  // Уʧ
  reset             // λ
  return
#endasm

/*  4 λ HEX (HEXļʹBCD) */
unsigned char gx(void)
{
  while(!RCIF);
  
  EEDATA=RCREG;
  if(EEDATA>='A')
    return ((EEDATA - (unsigned char)'A')+10);
  return (EEDATA - '0');
}

/* һ16ֽ, У */
unsigned char g2x(void)
{
  unsigned char temp = (gx()<<4);
  temp +=gx();
  cksum+=temp;
  return temp;
}

/* ʼдڴ */
void zap(void)
{
  WREN=1;
  EECON2=0x55;
  EECON2=0xAA;
  WR=1;
  NOP();
  while(WR);
  WREN=0;
}

/* RAMֽڵ flash Ĵ */
void table_write(void)
{
  if(DO_NOT_INCREMENT)  // ַѾ TBLPTR, ҪԤ
    asm("tblwt*");
  else
    asm("tblwt+*");     //  TBLPTR ҪԤ
  DO_NOT_INCREMENT=0;
}

/* д 8 ֽڻ flash */
void flash8(void)
{
  if(DO_NOT_INCREMENT)
    TBLPTRL&=0xF8;  // ָ 8 ֽڿ
  for(index=0;index<8;)
  {
    TABLAT = buff[index++];
    table_write();
  }
  zap();
}

void clear_buffer(void)
{
  buff[0] = buff[1] = buff[2] = FILL_BYTE;  // ֽ
  buff[3] = buff[4] = buff[5] = FILL_BYTE;
  buff[6] = buff[7] = FILL_BYTE;
}

void putch(char dat)
{
#if RS485 == 1
  TXEn = 1;
  TXREG = dat;
  while(TRMT==0);
  TXEn = 0;
#else
  TXREG = dat;
#endif
}

void main(void)
{

#if INTRC == 1
  OSCCON = 0x72;
#endif

#if RS485 == 1
  TXEn = OUTPUT;
#endif

  ADCON1 = 0x7F;

#if defined(_18F242) || defined(_18F252) || defined(_18F442) || defined(_18F452)
  PIE1=0; // ЩͺҪĴУ
#endif

  init_comms(); // ʼ

  // ĳЩͺŵ⣬ҪЩĴ
  INTCON3=0;    // Also serves to disable interrupts
  PIE2=0;
  INTCON=0;

#if BOOT_TIME_DELAY == 1
  //ʹóʱжϷʽ
  //ָʱյݣ״̬ǰĳ

  T0CON = 0x94; // ʹöʱʱ
  index = 0;

  for(delay_time=0;delay_time<BOOT_TIMEOUT;)
  {
    if (RCIF)   //ܵ
    {
      if(CONFIRM_DATA[index]==RCREG)index++;
      else index=0;
    }

#if USEWDT == 1
    CLRWDT();
#endif

    if(TMR0IF)  //ȴ1붨ʱ־
    {
      TMR0IF = 0;
      putch('0'+index);
      delay_time++;
    }
  }
  T0CON=0x7F; // ֹʱ

  if (index!=CONFIRM_TIME)//ʧ
  {
    (*((void(*)(void))PROG_START))(); //ֱӽû
  }
#endif

//ʹźжϷʽ
#if BOOT_SIGNAL == 1
  if (BOOT_SIGNAL_PORT = BOOT_SIGNAL_LEVEL)
  {
    (*((void(*)(void))PROG_START))(); //ֱӽû
  }
#endif

  TBLPTRU=0;
  erase=PROG_START;
  /* ռ */
  while(1)
  {
    TBLPTRL=(unsigned char)erase;
    TBLPTRH=(unsigned char)(erase>>8);
    EECON1=0x90;  // 
    zap();
    erase+=64;
#ifdef UPPER_ADDRESS_BYTE
    if(CARRY)
      TBLPTRU++;
    if(TBLPTRU==UPPER_ADDRESS_BYTE)
#endif
    if(erase==MEM_TOP)
      break;
#if USEWDT == 1
    CLRWDT();
#endif
  }

  putch(':');  // ʾ״̬

#ifdef UPPER_ADDRESS_BYTE
  TBLPTRU=0;
#endif

#if USE_ECHOBACK == 1
  SerialNo = 0;
#endif

/* ͨڽHEXļ */
  for(;;)   // ѭ
  {
#if USEWDT == 1
    CLRWDT();
#endif
    while (RCREG!=':');       // ȴ hex ļʼ

    cksum = bcount = g2x();   // ȡݳ
#if EEPROM_SIZE > 256
    EEADRH = TBLPTRH = g2x(); // ȡַ
#else
    TBLPTRH = g2x();
#endif
    TBLPTRL = EEADR = g2x();

    DO_NOT_INCREMENT = 1;
    rectype = g2x();          // ȡ

    switch(rectype)
    {
      case DATA:              // ݼ¼
#if (PROG_START > 0x200) || defined(__PIC18FX520) //  bootloader ַݣBootLoader
        if( (FLASH) && (TBLPTRU==0) && (TBLPTRH < (unsigned char)(PROG_START>>8)) )
          break;
#endif                    // һδΪ˱0x200Ĵõģ0x200ڵĴӲ

        clear_buffer();   //ջ
        while(bcount--)
        {
          TABLAT = EEDATA = buff[(EEADR&7)] = g2x();  // ȡ
          
          if((EEADR&7)==7)  // дEEPROM
          {
            flash8();
            clear_buffer();
          }
          EEADR++;
        }
        if((EEADR&7)!=0) flash8();
        checksum();

#if USE_ECHOBACK == 1
        putch(SerialNo++); //ʾдһ֡ɹ
#endif
        break;

      case END: // ļ
        checksum();
        putch(')');          //ʾɹ
        (*((void(*)(void))PROG_START))(); //³

        break;

#if USE_EXTEND_HEX == 1
      case EXTEND_ADDRESS:  // չַ¼
        while(bcount--)
        {
          EEADR=g2x();      //  EE, Config  ID 
        }

        EEPGD=1;
        if(EEADR==0xF0)
          EEPGD=0;          // EEPROM

        CFGS=0;
        if((EEADR&0xF0)==0x30)
          CFGS=1;           // дüĴ

        TBLPTRU=EEADR;
        checksum();

        break;
#endif
    }
  }
}

